Alembic: Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR > Class Template Reference

Alembic 1.8.11

Loading...
Searching...
No Matches
Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR > Class Template Reference

`#include <OBaseProperty.h>`

Inheritance diagram for Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >:

## Public Types
typedef OBasePropertyT< PROP_PTR > | this_type
typedef OBasePropertyT< PROP_PTR > | operator_bool_base_type

## Public Member Functions
const AbcA::PropertyHeader & | getHeader () const
const std::string & | getName () const
AbcA::PropertyType | getPropertyType () const
bool | isScalar () const
bool | isArray () const
bool | isCompound () const
bool | isSimple () const
const AbcA::MetaData & | getMetaData () const
const AbcA::DataType & | getDataType () const
AbcA::TimeSamplingPtr | getTimeSampling () const
OObject | getObject () const
PROP_PTR | getPtr () const
void | reset ()
bool | valid () const
| ALEMBIC_OPERATOR_BOOL (valid())
Public Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::Base
ErrorHandler & | getErrorHandler () const
ErrorHandler::Policy | getErrorHandlerPolicy () const

## Protected Member Functions
| OBasePropertyT ()
| OBasePropertyT (PROP_PTR iPtr, ErrorHandler::Policy iPolicy)
Protected Member Functions inherited from Alembic::Abc::ALEMBIC_VERSION_NS::Base
| Base (ErrorHandler::Policy iPolicy)
| Base (const Base &iCopy)
Base & | operator= (const Base &iCopy)
bool | valid () const
void | reset ()

## Protected Attributes
PROP_PTR | m_property

## Friends
class | OCompoundProperty

## Detailed Description

template<class PROP_PTR>
class Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >

Most of the functionality of properties (getting information about the properties and so on) is common to all property types, so we create a base class to contain all that functionality. This is purely a base class for other properties to derive from, it will never be created directly.

## Member Typedef Documentation

## ◆ this_type

template<class PROP_PTR>

typedef OBasePropertyT<PROP_PTR> Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::this_type

By convention we always define this_type in Abc classes Used by unspecified-bool-type conversion below

## Constructor & Destructor Documentation

## ◆ OBasePropertyT() [1/2]

template<class PROP_PTR>

Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::OBasePropertyT | ( |  | ) |
| inlineprotected

The default constructor creates an empty OBaseProperty function set. ...

## ◆ OBasePropertyT() [2/2]

template<class PROP_PTR>

Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::OBasePropertyT | ( | PROP_PTR | iPtr,
|  | ErrorHandler::Policy | iPolicy )
| inlineprotected

This attaches an OBaseProperty wrapper around an existing PROP_PTR, with the given error handler policy

Parameters

  iPtr | The pointer ...
  iPolicy | The error handling. ...

## Member Function Documentation

## ◆ ALEMBIC_OPERATOR_BOOL()

template<class PROP_PTR>

Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::ALEMBIC_OPERATOR_BOOL | ( | valid() |  | ) |

The unspecified-bool-type operator casts the object to "true" if it is valid, and "false" otherwise.

## ◆ getDataType()

template<class PROP_PTR>

const AbcA::DataType & Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::getDataType | ( |  | ) | const
| inline

Non-compound properties have a DataType. It is an error to call this function for CompoundProperties, and an exception will be thrown. This is a convenience function which just returns the DataType from the header that was used in creation.

## ◆ getHeader()

template<class PROP_PTR>

const AbcA::PropertyHeader & Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::getHeader | ( |  | ) | const

Default copy constructor used Default assignment operator used.

Return the property's header. ...

## ◆ getMetaData()

template<class PROP_PTR>

const AbcA::MetaData & Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::getMetaData | ( |  | ) | const
| inline

All properties have MetaData. This just returns the MetaData portion of the header that was used in creation.

## ◆ getName()

template<class PROP_PTR>

const std::string & Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::getName | ( |  | ) | const
| inline

This function returns the property's local name ...

## ◆ getObject()

template<class PROP_PTR>

OObject Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::getObject | ( |  | ) | const

This function returns the property's object, handily wrapped in an OObject wrapper.

## ◆ getPropertyType()

template<class PROP_PTR>

AbcA::PropertyType Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::getPropertyType | ( |  | ) | const
| inline

This function returns the property's type ...

## ◆ getPtr()

template<class PROP_PTR>

PROP_PTR Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::getPtr | ( |  | ) | const
| inline

Can't wrap OCompoundProperty getParent();

getPtr, as usual, returns a shared ptr to the underlying AbcCoreAbstract object, in this case the PROP_PTR.

## ◆ getTimeSampling()

template<class PROP_PTR>

AbcA::TimeSamplingPtr Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::getTimeSampling | ( |  | ) | const
| inline

Non-compound properties have a TimeSamplingPtr. It is an error to call this function for CompoundProperties, and an exception will be thrown. This is a convenience function which just returns the TimeSamplingPtr from the header that was used in creation.

## ◆ isArray()

template<class PROP_PTR>

bool Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::isArray | ( |  | ) | const
| inline

Convenience to return whether the property is array. Same as getPropertyType() == kArrayProperty

## ◆ isCompound()

template<class PROP_PTR>

bool Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::isCompound | ( |  | ) | const
| inline

Convenience to return whether the property is compound. Same as getPropertyType() == kCompoundProperty

## ◆ isScalar()

template<class PROP_PTR>

bool Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::isScalar | ( |  | ) | const
| inline

Convenience to return whether the property is scalar. Same as getPropertyType() == kScalarProperty

## ◆ isSimple()

template<class PROP_PTR>

bool Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::isSimple | ( |  | ) | const
| inline

Convenience to return whether the property is simple (non-compound) Same as getPropertyType() != kCompoundProperty

## ◆ reset()

template<class PROP_PTR>

void Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::reset | ( |  | ) |
| inline

Reset returns this function set to an empty, default state.

## ◆ valid()

template<class PROP_PTR>

bool Alembic::Abc::ALEMBIC_VERSION_NS::OBasePropertyT< PROP_PTR >::valid | ( |  | ) | const
| inline

Valid returns whether this function set is valid.

The documentation for this class was generated from the following file:

- Abc/OBaseProperty.h